package com.sun.facelets.tag.jsf.standard;

import java.io.IOException;
import java.util.Iterator;

import javax.faces.component.NamingContainer;
import javax.faces.component.UIComponent;
import javax.faces.component.html.HtmlSelectOneRadio;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import javax.faces.model.SelectItem;
import javax.faces.model.SelectItemGroup;
import javax.faces.render.Renderer;

import com.sun.facelets.el.ELAdaptor;

public class SelectOneRadioRenderer extends Renderer {

    public SelectOneRadioRenderer() {
        super();
        // TODO Auto-generated constructor stub
    }

    public void decode(FacesContext context, UIComponent component) {

        HtmlSelectOneRadio radio = (HtmlSelectOneRadio) component;

        // stop now if it's not rendered or disabled
        if (radio.isRendered() || radio.isDisabled() || radio.isReadonly()) {
            return;
        }

        // get our unique id
        String clientId = radio.getClientId(context);

        // determine if there's a value
        Object value = context.getExternalContext().getRequestParameterMap()
                .get(clientId);

        // assign it
        radio.setSubmittedValue(value);
    }

    public void encodeBegin(FacesContext context, UIComponent component)
            throws IOException {

        ResponseWriter out = context.getResponseWriter();
        HtmlSelectOneRadio radio = (HtmlSelectOneRadio) component;
        String clientId = radio.getClientId(context);

        String attr = null;
        StringBuffer buf = new StringBuffer(32);
        buf.append(clientId).append(NamingContainer.SEPARATOR_CHAR);

        // our prefix for children
        String childId = buf.toString();

        // start by rendering our outer structure
        out.startElement("dl", radio);
        out.writeAttribute("style", radio.getStyle(), "style");
        out.writeAttribute("class", radio.getStyleClass(), "styleClass");

        Iterator itr = StandardLibrary.getSelectItems(context, component);
        SelectItem itm;
        while (itr.hasNext()) {
            itm = (SelectItem) itr.next();
            if (itm instanceof SelectItemGroup) {
                SelectItemGroup grp = (SelectItemGroup) itm;

                out.startElement("dt", radio);
                out.writeText(grp.getLabel(), "label");
                out.endElement("dt");

                SelectItem[] grpItms = grp.getSelectItems();
                for (int i = 0; i < grpItms.length; i++) {
                    
                }
            }
        }

        // finish rendering outer bits
        out.endElement("dl");

    }

    private void encodeSelectItem(FacesContext context,
            HtmlSelectOneRadio radio, SelectItem item, String id, String name)
            throws IOException {
        ResponseWriter out = context.getResponseWriter();
        out.startElement("dd", radio);
        
        // scope disabled here since we can use nested selectors in css
        if (item.isDisabled()) {
            out.writeAttribute("class", radio.getDisabledClass(),
                    "disabledClass");
        } else {
            out.writeAttribute("class", radio.getEnabledClass(),
                    "enabledClass");
        }
        
        // start label?
        String label = item.getLabel();
        if (label != null) {
            out.startElement("label", radio);
            out.writeAttribute("for", id, null);
        }
        
        Object value = item.getValue();
        
        // write radio
        out.startElement("input", radio);
        out.writeAttribute("type", "radio", null);
        out.writeAttribute("id", id, null);
        out.writeAttribute("name", name, null);
        out.writeAttribute("value", value, null);
        
        // is it us?
        Object obj = radio.getSubmittedValue();
        Class type = String.class;
        //Object compare = ELAdaptor.getELContext(context).
        
        out.endElement("input");
        
        // end label?
        if (label != null) {
            out.writeText(label, "label");
            out.endElement("label");
        }
        
        out.endElement("dd");
    }

}
